#ifndef _DialogFileChooser_h
#define _DialogFileChooser_h

/*
 *	subtitle editor
 *
 *	http://kitone.free.fr/subtitleeditor/
 *
 *	Copyright @ 2005-2006, kitone
 *
 *	Contact: kitone at free dot fr
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public
 *	License as published by the Free Software Foundation; either
 *	version 2 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU
 *	General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public
 *	License along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA	02111-1307	USA
 *
 *	See gpl.txt for more information regarding the GNU General Public License.
 *
 *
 *	\file
 *	\brief 
 *	\author kitone (kitone at free dot fr)
 */

#include <gtkmm.h>
#include "Document.h"

/*
 *	utiliser en interne
 */
class EncodingsSelector;



class DialogFileChooser : public Gtk::FileChooserDialog
{
public:
	/*
	 *
	 */
	DialogFileChooser(const Glib::ustring &title, Gtk::FileChooserAction action=Gtk::FILE_CHOOSER_ACTION_OPEN, bool use_format=true);

	/*
	 * return "Auto Detected" or charset (UTF-8, ...)
	 */
	Glib::ustring getEncoding();

	/*
	 * return format saving ("SubRip", "MicroDVD", ...)
	 */
	Glib::ustring getFormat();

	/*
	 * exemple :
	 * name = "All Format Supported"
	 * patterns = "*.ssa;*.ass;*.sub;*.txt"
	 */
	void addFilter(const Glib::ustring &name, const Glib::ustring &patterns);
	
protected:
	EncodingsSelector* m_encodingsSelector;
};


#endif//_DialogFileChooser_h

